#include <iostream>

struct UnnamedClosureClass { // code generated by the compiler
    UnnamedClosureClass(double& _scale, int& _counter, const unsigned& _divider)
        : scale(_scale), counter(_counter), divider(_divider)
    {}

    inline auto operator()(int x, int y) const {
        return (x + y + counter++) * scale / divider;
    }

private:
    double scale;
    int& counter;
    unsigned divider;
};

int main() {
    double scale{ 2.5 };
    int counter{};
    
    /* closure */
    auto lambdaA = UnnamedClosureClass{scale, counter, 100u};

    /* same as above */
    auto lambdaB = [scale, &counter, divider = 100u](int x, int y) {
        return (x + y + counter++) * scale / divider;
    };

    std::cout << lambdaA(2, 5) << std::endl;
    counter = 0;
    std::cout << lambdaB(2, 5) << std::endl;

    return 0;
}
